/**
 * @file
 * Makes queued change functionality.
 */

Drupal.layoutbuilderExtrasLiveUpdateQueuedChange = Drupal.layoutbuilderExtrasLiveUpdateQueuedChange || {};

Drupal.layoutbuilderExtrasLiveUpdateQueuedChange.once = 'queued-change-once';
Drupal.layoutbuilderExtrasLiveUpdateQueuedChange.queuedTime = 1500;

(function () {
  Drupal.behaviors.layoutbuilderExtrasLiveUpdateQueuedChange = {
    attach: function (context) {
      const queuedChangeElements = document.querySelectorAll('[data-queued-change]');
      queuedChangeElements.forEach(function (queuedChangeElement) {
        if (queuedChangeElement.classList.contains(Drupal.layoutbuilderExtrasLiveUpdateQueuedChange.once)) {
          return;
        }
        queuedChangeElement.classList.add(Drupal.layoutbuilderExtrasLiveUpdateQueuedChange.once);

        queuedChangeElement.addEventListener('input', function (e) {
          if (e.target.classList.contains('queuing')) {
            return;
          }
          e.target.classList.add('queuing');

          setTimeout(function() {

            const event = new Event('queuedchange');
            e.target.dispatchEvent(event);
            e.target.classList.remove('queuing');

          }, Drupal.layoutbuilderExtrasLiveUpdateQueuedChange.queuedTime);
        });
      });
    }
  };
})();
