<?php

namespace Drupal\layoutbuilder_extras_live_update;

/**
 * Helper.
 */
class LayoutBuilderExtrasLiveUpdateHelper {

  /**
   * Should we attach to this element or not.
   *
   * @return boolean
   */
  public static function isElementApplicable($key, $element) {
    // Skip reserved form elements.
    if (str_contains($key, '#') || !is_array($element)) {
      return FALSE;
    }

    // Is it a "real" FAPI element?. Dumb check ofc.
    if (!isset($element['#type'])) {
      return FALSE;
    }

    // Check for empty to not override existing ajax callbacks like on MEdia.
    // For example the updateWidgt.
    if (!empty($element['#ajax']['callback'])) {
      return FALSE;
    }

    // Extra cleans.
    if (in_array($element['#type'], [
      'container',
      'fieldset',
      'button',
      'submit',
      'hidden',
    ])) {
      return FALSE;
    }

    return TRUE;
  }

}
